-- Ben Lin 5/98
class DISTINCT inherit OBSERVER
	-- Whenever a square is ticked, this puts crosses on all the other
	-- squares in the same row and column. If this is not possible, it
	-- will kill the blackboard. (Called `DISTINCT' because
	-- in logic problems, we would like A, B, C to have distinct jobs,
	-- for example)
creation make
feature
	make is
	do
	end

	update(last : ADD_TICK) is
	local
		i, j, x, y : INTEGER
		count : INTEGER
		bb : LP_BOARD
	do
		bb := last.bb
		i := last.i
		j := last.j
		x := last.x
		from
			y := 1
			count := 0
		until y > bb.size
		loop
			inspect(bb.board.item(i, j, x, y))
			when 0 then
				last.forced_cross(i, j, x, y)
			when 1 then
				count := count + 1
			else
			end
			y := y + 1
		end

		y := last.y

		if count > 1 then
			last.forced_die
		end

		from
			count := 0
			x := 1
		until x > bb.size
		loop
			inspect(bb.board.item(i, j, x, y))
			when 0 then
				last.forced_cross(i, j, x, y)
			when 1 then
				count := count + 1
			else
			end
			x := x + 1
		end

		if count > 1 then
			last.forced_die
		end
	end

end
