-- Ben Lin 28/5/98
class LARGER_THAN inherit OBSERVER
	-- Makes sure the value of the `attr'th attribute that
	-- corresponds to `bigi': `bigx'
	-- is greater than the value of the `attr'th attribute
	-- corresponding to `smalli': `smallx'
	-- (the notation a:b means the bth value of the ath attribute,
	-- e.g. 2:3 in "Limbering Up" (see limber.e) would mean the
	-- 3rd value of the 2nd attribute, i.e. the 3rd last name, "Wood")
creation make
feature
	make(bigi, bigx, smalli, smallx, attr : INTEGER) is
	do
		i1 := bigi
		x1 := bigx
		i2 := smalli
		x2 := smallx
		j := attr
	end

	update(last : LP_COMMAND) is
	local
		found : INTEGER
		y : INTEGER
		done : BOOLEAN
		bb : LP_BOARD
	do
		bb := last.bb

		-- find the maximum of bigi, bigx - smalli, smallx must be smaller
		-- than this
		from
			found := bb.size
			done := false
		until found = 1 or done
		loop
			inspect bb.board.item(i1, j, x1, found)
			when -1 then
				found := found - 1
			else
				done := true
			end
		end

		if found = 1 then
			-- if it's 1 or lower, there's no way it can be greater than
			-- anyting else
			last.forced_die
		else
			-- now cross out squares that imply small >= big
			from y := bb.size
			until y < found
			loop
				inspect bb.board.item(i2, j, x2, y)
				when 0 then
					last.forced_cross(i2, j, x2, y)
				when 1 then
					last.forced_die
				else
				end
				y := y - 1
			end
		end
	end

feature {NONE}
	i1, x1, i2, x2, j : INTEGER
end

