-- "Logic Grid"
-- Ben Lin
-- 27/5/98
--
-- Like an array, but only allowed to access item(i, j) if i /= j
-- and item(i, j) = item(j, i)
--

class LOGIC_GRID[E]
creation make
feature
	make(count, size : INTEGER) is
	local
		i : INTEGER
		j : INTEGER
		temp : ARRAY2[E]
	do
		!!storage.make(1, count, 1, count)
		from j := 2
		until j > count
		loop
			from i := 1
			until i = j
			loop
				!!temp.make(1, size, 1, size)
				storage.put(temp, i, j)
				i := i + 1
			end
			j := j + 1
		end
	end

	put(n : E; i, j, x, y : INTEGER) is
	require
		i /= j
	do
		if i < j then
			storage.item(i, j).put(n, x, y)
		else
			storage.item(j, i).put(n, y, x)
		end
	end

	is_equal(n : E; i, j, x, y : INTEGER) : BOOLEAN is
	do
		Result := item(i, j, x, y) = n
	end

	item(i, j, x, y : INTEGER) : E is
	require
		i /= j
	do
		if i < j then
			Result := storage.item(i, j).item(x, y) 
		else
			Result := storage.item(j, i).item(y, x)
		end
	end

feature {NONE}
	storage : ARRAY2[ARRAY2[E]]

end

