-- lp_command.e
--
-- Ben Lin, 5/98
--
-- An extra level of inheritance was brought in because
-- `ADD_TICK' and `ADD_CROSS' share a lot of code: for example,
-- they both need a location i, j, x, y,
-- and their display routines are similar.

class LP_COMMAND
inherit COMMAND
redefine bb, display
feature
	make(qb : LP_BOARD; sub_board_i, sub_board_j : INTEGER;
		x_coord : INTEGER; y_coord : INTEGER) is
	do
		bb := qb
		i := sub_board_i
		j := sub_board_j
		x := x_coord
		y := y_coord
	end

	display is
		-- show information about this command
	do
		io.put_string("Logic problem command, on coordinates: ")
		display_loc
	end

	bb : LP_BOARD
	i : INTEGER
	j : INTEGER
	x : INTEGER
	y : INTEGER

feature {OBSERVER}
	forced_tick(sub_board_i, sub_board_j : INTEGER;
		x_coord, y_coord : INTEGER) is
		-- observers call this when a forced tick is found
	local
		c : ADD_TICK
	do
		!!c.make(bb, sub_board_i, sub_board_j, x_coord, y_coord)
		forced_move.add_last(c)
	end

	forced_cross(sub_board_i, sub_board_j : INTEGER;
		x_coord, y_coord : INTEGER) is
		-- observers call this when a forced cross is found
	local
		c : ADD_CROSS
	do
		!!c.make(bb, sub_board_i, sub_board_j, x_coord, y_coord)
		forced_move.add_last(c)
	end

feature {NONE}

	display_loc is
	do
		io.put_integer(i)
		io.put_string(", ")
		io.put_integer(j)
		io.put_string(", ")
		io.put_integer(x)
		io.put_string(", ")
		io.put_integer(y)
		io.put_string("%N")

	end
end
